from collections import defaultdict

fib_mults = {144: (2, 3), 8: (2,)}


def fib(n):
    arr = [1] * 85
    first, second = 2, 3
    for i in range(n):
        if second > n:
            arr[i] = first
            return arr
        arr[i] = first
        first, second = second, first + second


def is_mult_two(num):
    while num % 2 == 0:
        num //= 2
    return num == 1


def cnt_two(num):
    cnt = 0
    while num % 2 == 0 and num != 0:
        num //= 2
        cnt += 1
    return cnt


def cnt_for_two_mult(n):
    cnt = cnt_two(n)

    return cnt // 3 + 1


fibs = fib(10 ** 18)
fib_d = {}
print(fibs)


def main():
    t = int(input())
    for _ in range(t):
        n = int(input())
        if n == 1:
            print(0)
            continue
        if is_mult_two(n):
            print(cnt_for_two_mult(n))
            continue
        div_cnt = defaultdict(int)
        cnt = 0

        for i in fibs[::-1]:
            while n % i == 0:
                div_cnt[i] += 1
                n //= i
        if n != 1:
            print(0)
            continue
        cnt_8 = div_cnt[2] // 3
        cnt_144 = min(div_cnt[2] // 2, div_cnt[3]) // 2
        cnt += cnt_8 + cnt_144 + 1
        for i in range(1, cnt_144 + 1):
            div_cnt[2] -= 4
            div_cnt[3] -= 2
            curr_cnt_8 = div_cnt[2] // 3
            cnt += curr_cnt_8
        print(cnt)
        continue


if __name__ == '__main__':
    main()
