def solve_for_one_engine(ai, bi, zi, p):
    z = zi
    if p <= ai * zi:
        x = (p + ai - 1) // ai
    else:
        x = zi
        x += (p - ai * zi + bi - 1) // bi
    print(x)


def solve_for_one_z(a, b, z, p):
    if p < a * z:
        x = (p + a - 1) // a
    else:
        x = z
        x += (p - a * z + b - 1) // b
    print(x)


def solve(a, b, z, p):
    zi = 0
    p_curr = sum(a)
    p_end = 0
    x = 0
    ind_past = 0
    ind = 0

    while p_end < p:
        if p < p_curr * z[zi][0] + p_end:
            x = (p + p_curr - 1) // p_curr
            p_end += x * p_curr
            break
        if zi > 0:
            x = z[zi][0] - z[zi - 1]
        else:
            x = z[zi][0]
        p_end += p_curr * x
        zi += 1
        ind_past = ind
        ind = z[zi][1]
        for i in range(ind_past, ind):
            p_curr += b[i]

    print(x)


def main():
    n, p = map(int, input().split())
    arr = []
    a = [0] * n
    b = [0] * n
    z = []
    for i in range(n):
        zi, ai, bi = map(int, input().split())
        arr.append((zi, ai, bi - ai))

    arr.sort()
    for i, v in enumerate(arr):
        a[i] = v[1]
        b[i] = v[2]
        z.append((v[0], i))

    solve(a, b, z, p)


if __name__ == '__main__':
    main()
